<?php
/*
 * Created on 26/04/2013
 *
 *Essa class tem as bibliotecas que gerencia requisição vindo do GMoodle
 */
 class report_gmoodlexreport_gm_request {
 	var $auth;
        var $code_cripty;
        var $code;
        var $data;
        var $failed;
        var $error;
        
        function __construct($auth=null,$code_cripty=null) {
             if(empty($auth)){
                 $this->auth=new report_gmoodlexreport_auth_cripty_gmtomdl();
               }
              else {$this->auth=$auth;}
             if(!empty($code_cripty)){$this->code_cripty=$code_cripty;}
         }
         
         
        
         public function get_code(){
            if(empty($this->code)){
                $code=R2::clean_format($this->code_cripty);
                $code=R2::decode_view($code);
                $this->code=R2::decode($this->auth->get_data()->cripty_info,$code);
               
            }
            
            return $this->code;
        }
    
        
     public function get_data(){
            if(empty($this->data)){
                $this->data=new stdClass();
                $this->data->version=$this->auth->get_value($this->get_code(),"001");
                $this->data->token=$this->auth->get_value($this->get_code(),"002");
                $this->data->token_control=$this->auth->get_value($this->get_code(),"009");
                $this->data->entity=$this->auth->get_value($this->get_code(),"003");
                $this->data->id_portal=$this->auth->get_value($this->get_code(),"004");
                $this->data->sql_type=$this->auth->get_value($this->get_code(),"011");
                $this->data->sql=$this->auth->get_value($this->get_code(),"010");
               }  
               
            return $this->data;
        }
      public function is_simple_data(){
          if($this->get_data()->sql_type=="M") return FALSE;
         else if($this->get_data()->sql_type=="S") return TRUE;
      }  
      public function get_sql(){
         return $this->get_data()->sql;
       }  
      public function validate_message(){ 
         
          if(empty($this->code_cripty)){
               $this->error=report_gmoodlexreport_gm_domain_table::$REQUEST_WIHTOUT_PARAM;
              $this->failed=TRUE;
              return false;
          }
          if($this->get_data()->token!=$this->auth->get_data()->token){
              $this->error=report_gmoodlexreport_gm_domain_table::$REQUEST_TOKEN_NOT_VALID;
              $this->failed=TRUE;
              return false;
           }
           
           if($this->get_data()->entity!=$this->auth->get_data()->entity){
              $this->error=report_gmoodlexreport_gm_domain_table::$REQUEST_ENTITY_NOT_VALID;
              $this->failed=TRUE;
              return false;
           }
           if($this->get_data()->id_portal!=$this->auth->get_data()->id_portal){
              $this->error=report_gmoodlexreport_gm_domain_table::$REQUEST_ID_PROTAL_NOT_VALID;
              $this->failed=TRUE;
              return false;
           }
      }
      
 }  